#xdxsmi completion                        -*- shell-script -*-

_xdxsmi()
{
    local cur prev pprev

    #Current word
    cur=${COMP_WORDS[COMP_CWORD]}

    #Previous word
    prev=${COMP_WORDS[COMP_CWORD-1]}

    #Wrod before previous word
    pprev=${COMP_WORDS[COMP_CWORD-2]}

    COMPREPLY=()

    #Options for xdxsmi
    xdxsmi_opts='clock power temp util fan thermal dvfs query_gpu list query vpuinfo vpumon'

    #Options for each module
    module_opts='get set'

    #Options for clock
    clock_opts='gfx'

    #Options for power
    power_opts='volt current pwr pwr_total'

    #Options for temp
    temp_opts='temp gddr_temp temp_highest temp_min temp_max temp_crit'

    #Options for util
    util_opts='gpu tdm geom 3d cdm'

    #Options for fan
    fan_opts='fan fan_min fan_max fan_ctrl_mode'

    #Options for thermal
    thermal_opts='temp_slowdown temp_shutdown enable_shutdown'

    #Options for dvfs
    dvfs_opts='enable_dvfs'

    #Options for query_gpu
    query_gpu_opts='uuid index temperature.gpu utilization.gpu utilization.memory memory.total memory.free memory.used clocks.gr'

    #Options for set
    set_opts=''

    #Options for pmon
    pmon_opts=''

    #Options for stats
    stats_opts=''


    #Print options based on previous word
    case $prev in

    #When previous word is xdxsmi
    xdxsmi)
        COMPREPLY=( $( compgen -W "$xdxsmi_opts" -- $cur) )
        ;;

    #When previous word is clock, power, thermal or fan
    clock | power | fan | thermal)
        COMPREPLY=( $( compgen -W "$module_opts" -- $cur) )
        ;;

    temp | util | query_gpu)
        COMPREPLY=( $( compgen -W "get" -- $cur) )
        ;;

    dvfs)
        COMPREPLY=( $( compgen -W "get set show" -- $cur) )
        ;;

    #When previous word is get
    get)
        if [ $pprev = 'clock' ]
        then
            COMPREPLY=( $( compgen -W "$clock_opts" -- $cur) )
        elif [ $pprev = 'power' ]
        then
            COMPREPLY=( $( compgen -W "$power_opts" -- $cur) )
        elif [ $pprev = 'temp' ]
        then
            COMPREPLY=( $( compgen -W "$temp_opts" -- $cur) )
        elif [ $pprev = 'util' ]
        then
            COMPREPLY=( $( compgen -W "$util_opts" -- $cur) )
        elif [ $pprev = 'fan' ]
        then
            COMPREPLY=( $( compgen -W "$fan_opts" -- $cur) )
        elif [ $pprev = 'thermal' ]
        then
            COMPREPLY=( $( compgen -W "$thermal_opts" -- $cur) )
        elif [ $pprev = 'dvfs' ]
        then
            COMPREPLY=( $( compgen -W "$dvfs_opts" -- $cur) )
        elif [ $pprev = 'query_gpu' ]
        then
            COMPREPLY=( $( compgen -W "$query_gpu_opts" -- $cur) )
        fi
        ;;
    
    #When previous word is set
    set)
        if [ $pprev = 'clock' ]
        then
            COMPREPLY=( $( compgen -W "gfx" -- $cur) )
        elif [ $pprev = 'power' ]
        then
            COMPREPLY=( $( compgen -W "pwr_warn volt" -- $cur) )
        elif [ $pprev = 'fan' ]
        then
            COMPREPLY=( $( compgen -W "fan_ctrl_mode fan" -- $cur) )
        elif [ $pprev = 'thermal' ]
        then
            COMPREPLY=( $( compgen -W "temp_slowdown temp_shutdown enable_shutdown" -- $cur) )
        elif [ $pprev = 'dvfs' ]
        then
            COMPREPLY=( $( compgen -W "enable_dvfs" -- $cur) )
        fi
        ;;
    
    #When inputing several attributes, do nothing
    *)
        ;;
    esac
}

#Apply the autocompletion function on the keyword 'xdxsmi'
complete -F _xdxsmi xdxsmi