# xdxsmi User Manual
* __INTRODUCTION__
    * xdxsmi, whose fullname is XDX System Management Interface Program, is a commandline tool which is used by users to conveniently monitor and control attributes of xdxgpu 
* __COMMANDS DISPLAY__
    * __Commands for `xdxsmi`__
      * Print usage information of xdxsmi
        > `$xdxsmi -h | --help`     
        > usage  
        > &emsp; xdxsmi [\<command>] [\<args>...]   
        > options:  
        > &emsp; xdxsmi -h, &nbsp; --help  &emsp;&nbsp; Show this screen infomation   
        > &emsp; xdxsmi --version          &nbsp;&nbsp;&nbsp;&emsp; Show version of xdxsmi  
        > commands:  
        > &emsp; clock     &nbsp; &nbsp; &nbsp; &emsp;  Control and query clock information  
        > &emsp; thermal   &nbsp; &nbsp; &nbsp;         Control and query thermal information  
        > &emsp; power     &nbsp; &nbsp; &emsp;         Control and query power information  
        > &emsp; fun       &nbsp; &nbsp; &emsp; &emsp;  Control and query fun information  
        > See 'xdxsmi <command> -h' for more information on a specific command.  
        > Run 'xdxsmi' without any options or commands will print a general gpu status.

      * Print version information
        > `$xdxsmi --version`  
        > 0.0.1



    * __Commands for `xdxsmi clock`__
      * Print usage information of xdxsmi clock
        > `$xdxsmi clock -h | --help`  
        > usage:  
        > &emsp; xdxsmi clock [options] get [\<ip>...]  
        > &emsp; xdxsmi clock [options] set gfx \<mhz>  
        > options:  
        > &emsp; -h, &nbsp; --help  &nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp;    print this help message  
        > &emsp; -i <idx>, &nbsp; --index=<idx>   &emsp; index number of target GPU, starting from 0 [default: -1]
      
      * Get clock frequency information of all gpus  
        > `$xdxsmi clock get`  
        > | INDEX   | GPU          | NAME     | HOST     | GFX      | GDDR     | ACPU     | NDF     | 
        > | ------- | -----        | -------  | -----    | -------  | -----    | -------  | -----   | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 600.0GHz | 750MHz   | 800.0GHz | 120.0GHz | 800.0GHz|  
        > | 1       | 0000:00:02.0 | PANGU_A1 | 700.0GHz | 750MHz   | 800.0GHz | 140.0GHz | 800.0GHz| 

      * Get specific clock frequency information of all gpus  
        > `$xdxsmi clock get host acpu`  
        > | INDEX   | GPU          | NAME     | HOST     | ACPU     | 
        > | ------- | -----        | -------  | -----    | -------  | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 600.0GHz | 120.0GHz |  
        > | 1       | 0000:00:02.0 | PANGU_A1 | 700.0GHz | 140.0GHz |  
          
      * Get all clock frequency information of a target gpu  
        > `$xdxsmi clock --index=0 get`  
        > | INDEX   | GPU          | NAME     | HOST     | GFX      | GDDR     | ACPU     | NDF     | 
        > | ------- | -----        | -------  | -----    | -------  | -----    | -------  | -----   | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 600.0GHz | 750MHz   | 800.0GHz | 120.0GHz | 800.0GHz|  

      * Get specific clock frequency information of a target gpu  
        > `$xdxsmi clock --index=0 get host acpu`  
        > | INDEX   | GPU          | NAME     | HOST     | ACPU     | 
        > | ------- | -----        | -------  | -----    | -------  | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 600.0GHz | 120.0GHz |  

      * Set attribute 'gfx' of a target gpu (valid)  
        > `$xdxsmi clock --index=0 set gfx 750`  
        > | INDEX   | GPU          | NAME     | GFX    |  
        > | ------- | -----        | -------  | -----  |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 750MHz |  

      * Set attribute 'gfx' for a target gpu (unvalid)  
        > `$xdxsmi clock --index=0 set gfx 3080`  
        > [XDXSMI ERROR]: Invalid input clock frequency 3080 MHz   
        > [XDXSMI ERROR]: PANGU_A0 gfx clock only supports [200, 600, 700, 750, 800]   



    * __Commands for `xdxsmi power`__
      * Print usage information of xdxsmi power
        > `$xdxsmi power -h | --help`  
        > usage:  
        > &emsp; xdxsmi power [options] get [\<ip>...]  
        > &emsp; xdxsmi power [options] set pwr_warn \<mhz>  
        > options:  
        > &emsp; -h, &nbsp; --help  &nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp;    print this help message  
        > &emsp; -i <idx>, &nbsp; --index=<idx>   &emsp; index number of target GPU, starting from 0 [default: -1]
      
      * Get all power information of all gpus  
        > `$xdxsmi power get`  
        > | INDEX   | GPU          | NAME     | VOLT  | CURR   | PWR   | PWR_MAX | PWR_MIN | PWR_WARN | 
        > | ------- | -----        | -------  | ----- | -----  | ----- | ------- | -----   | -----    |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.8V  | 0.5A   | 0.02W | 1.0W    | 0.1W    | 1.0W     |
        > | 1       | 0000:00:02.0 | PANGU_A1 | 1.0V  | 1.0A   | 0.05W | 2.0W    | 0.2W    | 2.0W     | 
      
      * Get specific power information of all gpus  
        > `$xdxsmi power get volt curr pwr`  
        > | INDEX   | GPU          | NAME     | VOLT  | CURR   | PWR   |  
        > | ------- | -----        | -------  | ----- | -----  | ----- |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.8V  | 0.5A   | 0.02W |  
        > | 1       | 0000:00:02.0 | PANGU_A1 | 1.0V  | 1.0A   | 0.05W |
      
      * Get all power information of a target gpu  
        > `$xdxsmi power --index=0 get`  
        > | INDEX   | GPU          | NAME     | VOLT  | CURR   | PWR   | PWR_MAX | PWR_MIN | PWR_MAX | 
        > | ------- | -----        | -------  | ----- | -----  | ----- | ------- | -----   | -----   |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.8V  | 0.5A   | 0.02W | 1.0W    | 0.1W    |  1.0W   | 
      
      * Get specific power information of a target gpu  
        > `$xdxsmi power --index=0 get volt curr`  
        > | INDEX   | GPU          | NAME     | VOLT  | CURR   |  
        > | ------- | -----        | -------  | ----- | -----  |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.8V  | 0.5A   | 
      
      * Set power attribute 'pwr_warn' for a target gpu  
        > `$xdxsmi power --index=0 set pwr_warn 10000`  
        > | INDEX   | GPU          | NAME     | PWR_WARN |  
        > | ------- | -----        | -------  | -----    |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.01W    |     



    * __Commands for `xdxsmi thermal`__  
      * Print usage information of xdxsmi thermal
        > `$xdxsmi thermal -h | --help`  
        > usage:  
        > &emsp; xdxsmi thermal [options] get [\<ip>...]  
        > &emsp; xdxsmi thermal [options] set temp_ctrl \<mhz>  
        > options:  
        > &emsp; -h, &nbsp; --help  &nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp;    print this help message  
        > &emsp; -i <idx>, &nbsp; --index=<idx>   &emsp; index number of target GPU, starting from 0 [default: -1]
      
      * Get all thermal information of all gpus  
        > `$xdxsmi thermal get`  
        > | INDEX   | GPU          | NAME     | TEMP   | TEMP_HIGH | TEMP_CTRL | 
        > | ------- | -----        | -------  | -----  | -----     | -----     |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 10.0°C | 0.0°C     | 0.0°C     |
        > | 1       | 0000:00:02.0 | PANGU_A1 | 15.0°C | 0.0°C     | 0.0°C     | 
      
      * Get specific thermal information of all gpus  
        > `$xdxsmi thermal get temp_high temp_ctrl`  
        > | INDEX   | GPU          | NAME     | TEMP_HIGH | TEMP_CTRL | 
        > | ------- | -----        | -------  | -----     | -----     |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.0°C     | 0.0°C     |
        > | 1       | 0000:00:02.0 | PANGU_A1 | 0.0°C     | 0.0°C     | 
      
      * Get all thermal information of a target gpu  
        > `$xdxsmi thermal --index=0 get`  
        > | INDEX   | GPU          | NAME     | TEMP   | TEMP_HIGH | TEMP_CTRL | 
        > | ------- | -----        | -------  | -----  | -----     | -----     |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 10.0°C | 0.0°C     | 0.0°C     |
      
      * Get specific thermal information of a target gpu  
        > `$xdxsmi thermal --index=0 get temp_high temp_ctrl`  
        > | INDEX   | GPU          | NAME     | TEMP_HIGH | TEMP_CTRL | 
        > | ------- | -----        | -------  | -----     | -----     |
        > | 0       | 0000:00:01.0 | PANGU_A0 | 0.0°C     | 0.0°C     |
      
      * Set thermal attribute 'temp_ctrl' for a target gpu  
        > `$xdxsmi thermal --index=0 set temp_ctrl 10000`  
        > | INDEX   | GPU          | NAME     | TEMP_CTRL |  
        > | ------- | -----        | -------  | -----     |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 10.0°C    | 



    * __Commands for `xdxsmi fan`__
      * Print usage information of xdxsmi fan
        > `$xdxsmi fan -h | --help`  
        > usage:  
        > &emsp; xdxsmi fan [options] get [\<ip>...]  
        > &emsp; xdxsmi fan [options] set tgt_spd \<mhz>  
        > options:  
        > &emsp; -h, &nbsp; --help  &nbsp;&nbsp;&emsp;&emsp;&emsp;&emsp;    print this help message  
        > &emsp; -i <idx>, &nbsp; --index=<idx>   &emsp; index number of target GPU, starting from 0 [default: -1]    
      
      * Get all fan information of all gpus  
        > `$xdxsmi fan get`  
        > | INDEX   | GPU          | NAME     | SPD    | TGT_SPD |  
        > | ------- | -----        | -------  | -----  | -----   | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 100RPM | 200RPM  | 
        > | 1       | 0000:00:02.0 | PANGU_A1 | 150RPM | 200RPM  | 
      
      * Get specific fan information of all gpus  
        > `$xdxsmi fan get spd`  
        > | INDEX   | GPU          | NAME     | SPD    |  
        > | ------- | -----        | -------  | -----  | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 100RPM | 
        > | 1       | 0000:00:02.0 | PANGU_A1 | 150RPM | 
      
      * Get all fan information of a target gpu  
        > `$xdxsmi fan --index=0 get`  
        > | INDEX   | GPU          | NAME     | SPD    | TGT_SPD |  
        > | ------- | -----        | -------  | -----  | -----   | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 100RPM | 200RPM  | 
      
      * Get specific fan information of a target gpu  
        > `$xdxsmi fan --index=0 get spd`  
        > | INDEX   | GPU          | NAME     | SPD    |  
        > | ------- | -----        | -------  | -----  | 
        > | 0       | 0000:00:01.0 | PANGU_A0 | 100RPM | 
      
      * Set fan attribute 'tgt_spd' for a target gpu  
        > `$xdxsmi fan --index=0 set tgt_spd 180`  
        > | INDEX   | GPU          | NAME     | TGT_SPD |  
        > | ------- | -----        | -------  | -----   |  
        > | 0       | 0000:00:01.0 | PANGU_A0 | 180RPM  | 