"""
usage:
   xdxsmi list [options]

options:
    -h, --help                    print this help message
"""

# from typing import Dict
from xdxsmi_render import Render
from xdxsmi_attrs_ops import setAttrs, getAttrs
from xdxsmi.api.third_party_docopt import docopt
from xdxsmi.api.smi import XdxSmi
from xdxsmi.api.pyxdxml import *
from xdxsmi.api.xdxgpu import XdxGpu


xdxgpu_list_template = \
"""\
# GPU           PCI
  {gpu}           {pci}
""".format(gpu='N/A', pci='N/A')

list_map = {
    "gpu" : "xdx_dbdf",
    "name": "xdx_product_name"
}

# (xdx_smi: XdxSmi, args: Dict)
def handle1(xdx_smi, args):
    target_gpus = []
    target_ip = ["gpu", "name"]
    #getAttrs(xdx_smi, args, target_ip, target_gpus, list_map)  
    print(xdxgpu_list_template)
    
# (xdx_smi: XdxSmi, args: Dict)
def handle(xdx_smi, args):
    #Collect target gpus
    #target_gpus = [xdx_smi.handle[0]]
    target_gpus = xdx_smi.handle
    data = []
    i = 0
    header = ["index", "PCI", "name"] 
    data.insert(0, header)
    for xdev in target_gpus:
        #clkInfo = xdxml_device_get_clock(xdev)
        #print(clkInfo)
        row = [
            str(i),
            xdxml_device_get_pci_info(xdev).pci_dbdf.decode("utf8"),
            xdxml_device_get_device_model(xdev).decode('utf-8')]
        data.append(row)
        i += 1
    #print(data)
    #Render.render_table(data, args)
    for i in range(len(data[0])):
        data[0][i] = data[0][i].upper()
    horizen=True
    padding=3
    if not horizen:
        # transpose the input data matrix to get a vertical output
        data = list(map(list, zip(*data)))
    # get colomn width
    column_width_list = [
        max(map(lambda row: len(row[col]), data)) + padding\
        for col in range(len(data[0]))
    ]
    content = ""
    for row in data:
        for i, element in enumerate(row):
            width = column_width_list[i]
            content += ("{element:<{width}}".format(element=element, width=width))
        content += "\n"
    print(content)

if __name__ == "__main__":
    print(docopt(__doc__))