
from __future__ import print_function
# from typing import Dict
# from typing import List
import time
import sys

class Render():
    # (data: List[List[str]], args: Dict, horizen=True, padding=3, upper=True) -> None
    # gap = max(13, len(elem)+3)
    @staticmethod
    def render_table(data, args, horizen=True, padding=3, upper=True):
        try:
            # transform titles to upper case
            for i in range(len(data[0])):
                if(upper == True): 
                    data[0][i] = data[0][i].upper()
            if not horizen:
                # transpose the input data matrix to get a vertical output
                data = list(map(list, zip(*data)))
            # get colomn width
            column_width_list = [
                max(list(map(lambda row: len(row[col]), data))) + padding
                for col in range(len(data[0]))
            ]
            content = ""
            for row in data:
                for i, element in enumerate(row):
                    width = column_width_list[i]
                    content += "{element:<{width}}".format(element=element, width=width)
                content += "\n"

            if(args['--filename'] != None):
                fo = open(args['--filename'], "a")
                fo.write(content + '\n')
                fo.close()
            else:
                print(content)
        except Exception as e:
            sys.exit("Exception: {0} \nPlease try another way or contact the software provider.".format(e))
            

    @staticmethod
    def render_table_py2(data, args, horizen=True, padding=3, upper=True):
        try:
            # transform titles to upper case
            for i in range(len(data[0])):
                if(upper == True): 
                    data[0][i] = data[0][i].upper()
            if not horizen:
                # transpose the input data matrix to get a vertical output
                data = list(map(list, zip(*data)))
            # get colomn width
            column_width_list = [
                max(list(map(lambda row: len(row[col]), data))) + padding
                for col in range(len(data[0]))
            ]
            content = ""
            cur_line = 0
            for row in data:
                for i, element in enumerate(row):
                    width = column_width_list[i]
                    if cur_line > 0 and i > 2:
                        width += 1
                    content += "{element:<{width}}".format(element=element, width=width)
                content += "\n"
                cur_line += 1

            if(args['--filename'] != None):
                with open(args['--filename'], "a") as fo:
                    fo.write(content + '\n')
            else:
                print(content)
       
        except Exception as e:
            sys.exit("Exception: {0} \nPlease try another way or contact the software provider.".format(e))

            
    @staticmethod
    def render_content(content, args, end='\n'):
        try:
            if(args['--filename'] != None):            
                with open(args['--filename'], "a") as fo:
                    print(content, end=end, file=fo)
            else:
                print(content, end=end)
        except Exception as e:
            sys.exit("Exception: {0} \nPlease try another way or contact the software provider.".format(e))   
            

if __name__ == "__main__":
    data = [
        ["fdsf","dsf","dsf"],
        ["11","2","3"],
        ["1","2","3333"],
        ["111","2333ddd","3"],
    ]
    Render.render_table(data, horizen=False)
    Render.render_table(data, padding=6)
