/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __DEC_400_H__
#define __DEC_400_H__

#include <drm/drm_fourcc.h>
#include "dm.h"
#include "dm_dec.h"

/* DEC_READ_CONFIG */
#define COMPRESSION_EN              BIT(0)
#define COMPRESSION_FORMAT_MASK     GENMASK(7, 3)
#define COMPRESSION_ALIGN_MODE_MASK GENMASK(17, 16)
#define TILE_MODE_MASK              GENMASK(30, 25)

/* DEC_READ_EX_CONFIG */
#define BIT_DEPTH_MASK          GENMASK(18, 16)

/* DEC_CONTROL */
#define FLUSH_ENABLE            BIT(0)
#define COMPRESSION_DISABLE     BIT(1)

/* DEC_CONTROL_EX */
#define WRITE_MISS_POLICY1      1
#define WRITE_MISS_POLICY_MASK  BIT(19)
#define READ_MISS_POLICY0       0
#define READ_MISS_POLICY_MASK   BIT(29)

/* DEC_CONTROL_EX2 */
#define TILE_STATUS_READ_ID         16
#define TILE_STATUS_READ_ID_MASK    GENMASK(6, 0)
#define TILE_STATUS_READ_ID_H       0
#define TILE_STATUS_READ_ID_H_MASK  GENMASK(23, 22)
#define DISABLE_HW_DEC_FLUSH        BIT(28)

/* DEC400 register */
#define DEC_CONTROL               0x0800
#define DEC_CONTROL_EX            0x0804
#define DEC_CONTROL_EX2           0x0808

#define DEC_READ_CONFIG           0x0880
#define DEC_READ_EX_CONFIG        0x0900
#define DEC_READ_BUFFER_BASE      0x0A80
#define DEC_READ_BUFFER_END       0x0B80
#define DEC_READ_CACHE_BASE       0x1080

#define DEC_CONTROL_RESET         0x0301018A
#define DEC_CONTROL_EX_RESET      0x00080000
#define DEC_CONTROL_EX2_RESET     0x103FC810
#define DEC_READ_CONFIG_RESET     0x00020000

struct dec400l {
	struct dec_stream stream[STREAM_TOTAL];
	u32 stream_status;
};

int dec4001_config(struct dec400l *dec400l, struct dec_fb *dec_fb,
		   u8 stream_base);

int dec4001_commit(struct dec400l *dec400l, struct dm_dc *dc);

#endif /* __DEC_400_H__ */