/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#include "dm_encoder.h"
#include "xdx_device.h"
#include "dm_dc.h"
#include "dm_connector.h"

static void xdx_dm_encoder_destroy(struct drm_encoder *encoder)
{
	struct dm_encoder *dm_encoder = to_dm_encoder(encoder);

	drm_encoder_cleanup(encoder);
	kfree(dm_encoder);
}

static const struct drm_encoder_funcs dm_encoder_funcs = {
	.destroy = xdx_dm_encoder_destroy,
};


static void xdx_dm_encoder_helper_dpms(struct drm_encoder *encoder, int mode)
{
    // TODO:
}

static void xdx_dm_encoder_helper_prepare(struct drm_encoder *encoder)
{
    // TODO:
}

static void xdx_dm_encoder_helper_commit(struct drm_encoder *encoder)
{
    // TODO:
}

static void
xdx_dm_encoder_helper_mode_set(struct drm_encoder *encoder,
				 struct drm_display_mode *mode,
				 struct drm_display_mode *adjusted_mode)
{
    // TODO:
}

/*
static int
xdx_dm_encoder_helper_atomic_check(struct drm_encoder *encoder,
			       struct drm_crtc_state *crtc_state,
			       struct drm_connector_state *conn_state)
{
	if (!crtc_state->connectors_changed && !crtc_state->mode_changed)
		return 0;
	// TODO:

	return 0;
}
*/

static bool
xdx_dm_encoder_helper_mode_fixup(struct drm_encoder *encoder,
				   const struct drm_display_mode *mode,
				   struct drm_display_mode *adjusted_mode)
{
    // TODO:
	return true;
}

const struct drm_encoder_helper_funcs dm_encoder_helper_funcs = {
	.dpms = xdx_dm_encoder_helper_dpms,
	.mode_fixup = xdx_dm_encoder_helper_mode_fixup,
	.prepare = xdx_dm_encoder_helper_prepare,
	.commit = xdx_dm_encoder_helper_commit,
	.mode_set = xdx_dm_encoder_helper_mode_set,
	.detect = NULL,
	.disable = NULL,
};

int dm_encoder_init(struct xdx_dm *dm, struct dm_encoder *dm_encoder,
		    uint32_t id)
{
	struct xdx_device *xdev = dm_to_xdev(dm);
	struct drm_device *ddev = xdev_to_drm(xdev);
	int ret;

	ret = drm_encoder_init(ddev, &dm_encoder->base, &dm_encoder_funcs,
			       DRM_MODE_ENCODER_TMDS, NULL);

	dm_encoder->base.possible_crtcs = dm_dc_get_crtc_mask(dm->dc[id]);


	if (!ret)
		dm_encoder->id = id;
	else
		dm_encoder->id = -1;

	drm_encoder_helper_add(&dm_encoder->base, &dm_encoder_helper_funcs);

	return ret;
}
