/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_DOORBELL_H__
#define __XDX_DOORBELL_H__
#include "dm.h"

#define DISPLAY_TRANSFER_PARA_BASE	(0x00000)
#define DISPLAY_TRANSFER_PARA_SIZE	(0x200)

#define DP_TRANSFER_PARA_OFFSET		(0x000)
#define HDMI_TRANSFER_PARA_OFFSET	(0x200)

typedef enum {
	cH02AHDMISubCmdPhyInit = 0,
	//cH02AHDMISubCmdAvpInit,
	cH02AHDMISubCmdI2CInit,
	cH02AHDMISubCmdI2COpt,
	cH02AHDMISubCmdPowerOn,
	cH02AHDMISubCmdPowerDown,
	cH02AHDMISubCmdMax
} H02AHDMISubCmdType_T;

typedef enum {
	cH02ADisplayDBCmdDebug = 0,
	cH02ADisplayDBCmdHDMI,
	cH02ADisplayDBCmdDP,
	cH02ADisplayDBCmdMax
} H02ADisplayDBCmdType_T;

typedef union {
	u64 all;
        struct {
                u32 low32;
                u32 high32;
        };
	struct {
		u64 done:	1;
		u64 cmd:	3;
		u64 subCmd:	4;
		u64 args0  :8;
		u64 ret:	8;
		u64 args1:	8;
		u64 dword:  32;
	};
} HDMIDBCmd_T_SINK;

typedef union {
	u64 all;
        struct {
                u32 low32;
                u32 high32;
        };
	struct {
		u32 done : 1;
		u32 cmd : 3;
		u32 subCmd : 4;
		/*u32 resv    :24;
		struct{
			u16   screenMode;
			u8    colorDepth;
			u8    colorFormat;
		};*/
		u32 resv : 8;
		u32 colorDepth : 8;
		u32 colorFormat : 8;
		u32 screenMode;
	};
} HDMIDBCmd_T_NOSINK;

typedef enum {
        cH02ADPSubCmdCNTLConfig,
        cH02ADPSubCmdCNTLPreConfig,
        cDPCmdHDMIReset,
        cDPCmdHDMIPoweron,
        cDPCmdHDMIPowerdown,
        cDPCmdHDMIPhyReset,
        cDPCmdHDMIPhyResetRelease,
        cDPCmdMax
} H02ADPSubCmdType_T;

typedef union {
        u64 all;
        struct {
                u32 low32;
                u32 high32;
        };
        struct {
                u64 done : 1;
                u64 cmd : 3;
                u64 subCmd : 4;
                //u64 data   : 56;
                u64 args0 : 8;
				u64 ret   : 8;
				u64 revs  : 8;
                u64 dword : 32;
        };
} DPDBCmd_T_SINK;

typedef union {
        u64 all;
        struct {
                u32 low32;
                u32 high32;
        };
        struct {
                u64 done : 1;
                u64 cmd : 3;
                u64 subCmd : 4;
                //u64 data   : 56;
                u64 resv : 24;
                u64 dcpixclock : 32;
        };
} DPDBCmd_T_NOSINK;

typedef enum {
	cHDMIDBCmdPhyInit = 0,
	cHDMIDBCmdMax
} HDMIDBCmdType_T;

typedef enum {
        cDPCmdDebug = 0,
        cDPCmdPLLConfig,
} DPCmdType_T;

#if !defined(SUPPORT_PANGU_ACPU)
static inline int DPDoorbellShareMemAllocate(struct xdx_output *output, u32 index)
{
	return -EINVAL;
}

static inline void DPDoorbellShareMemFree(struct xdx_output *output, u32 index)
{
	return;
}
#else
int DPDoorbellShareMemAllocate(struct xdx_output *output,u32 index);
void DPDoorbellShareMemFree(struct xdx_output *output,u32 index);
#endif
#endif
