/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_TILE_REG_H__
#define __XDX_TILE_REG_H__

/*****************************************************************************
 *                                                                           *
 *                            TILE Registers                            *
 *                                                                           *
 *****************************************************************************/
//Tx PHY Configuration
#define HDMI_PHY_CTRL				    0x00000000
#define SRAM_BOOTLOAD_BYPASS		    0x00000001
#define SRAM_BYPASS    		            0x00000002
#define SRAM_EXT_LD_DONE                0x00000003

#define HDMI_HPD_CTRL                   0x00000060
#define HPD_ENVENT_EN                   0x1
#define HPD_UNPLUG_ERR_EN               (1<<1)
#define HPD_UNPLUG_EN                   (1<<2)
#define HPD_PLUG_EN                     (1<<3)
#define HPD_IRQ_EN                      (1<<4)
#define FORCE_HPD                       (1<<5)

#define HDMI_HPD_INT_STATUS             0x0000006C
#define TILE_HPD_EVENT                  0x00000000
#define TILE_HPD_STATE                  0x00000700
#define TILE_HPD_STATUS                 0x00000800
#define TILE_HPD_OFFSET                 0x0000000B 
#define HPD_STATUS_MASE                 (1 << 11)

#define HPD_EVENT_RAW                  (1 << 0)
#define HPD_UNPLUG_ERR_RAW             (1 << 1)
#define HPD_UNPLUG_RAW                 (1 << 2)
#define HPD_PLUG_RAW                   (1 << 3)
#define HPD_IRQ_RAW                    (1 << 4)

#define  ALL_HDMIDP_PHY_IF_CLR  0xa4
#define  ALL_HDMIDP_PHY_IF_RAW  0xa8
#define  ALL_HDMI_PHY_CTRL      0x0
#define  ALL_HDMI_PCS_CTRL      0x8
#define  ALL_HDMI_HPD_CTRL      0x60
#define  ALL_HDMI_HPD_CLR       0x64
#define  ALL_HDMI_HPD_RAW_STATUS  0x68
#define  ALL_HDMI_HPD_INT_STATUS  0x6c

#define  HPD_EVENT                    (1 << 0)
#define  HPD_UNPLUG_ERR               (1 << 1)
#define  HPD_HOT_UNPLUG               (1 << 2)
#define  HPD_HOT_PLUG                 (1 << 3)
#define  HPD_IRQ                      (1 << 4)
#define  HPD_STATE                    (7 << 8)
#define  HPD_STATE_MASK               0x7
#define  HPD_STATUS                   (1 << 11)

#define  PHYREF_PLL_EN         0x44
#define  PHYREF_PLL_LOCK       0x5c
#define  DP_PHY_CTRL           0x04
#define  DP_CTRL               0x18
#define  DP_PCS_CTRL           0x0c


#endif
