/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef _XDX_DMA_DEBUGFS_H_
#define _XDX_DMA_DEBUGFS_H_

#include "xdx_dma_drv.h"
#include "xdx_dma.h"


#define XDX_DMA_DBG(sdc, fmt, ...) do{ \
	if(xdx_get_vdma_dbglevel() >= 3) { \
		if(sdc) \
			dev_info(sdc, fmt, ## __VA_ARGS__); \
		else \
			pr_info(fmt, ## __VA_ARGS__); \
	} \
}while(0)

#define XDX_DMA_WARN(sdc, fmt, ...) do{ \
	if(xdx_get_vdma_dbglevel() >= 2) { \
		if(sdc) \
			dev_warn(sdc, fmt, ## __VA_ARGS__); \
		else \
			pr_warn(fmt, ## __VA_ARGS__); \
	} \
}while(0)

#define XDX_DMA_INFO(sdc, fmt, ...) do{ \
	if(xdx_get_vdma_dbglevel() >= 1) { \
		if(sdc) \
			dev_info(sdc, fmt, ## __VA_ARGS__); \
		else \
			pr_info(fmt, ## __VA_ARGS__); \
	} \
}while(0)

#define XDX_DMA_ERR(sdc, fmt, ...) do{ \
	if(xdx_get_vdma_dbglevel() >= 0) { \
		if(sdc) \
			dev_err(sdc, fmt, ## __VA_ARGS__); \
		else \
			pr_err(fmt, ## __VA_ARGS__); \
	} \
}while(0)

#define XDX_DMA_PRINT(var, ...) do{ \
	if(xdx_get_vdma_dbglevel() >= 4) \
		pr_info(var, ## __VA_ARGS__); \
}while(0)

#define XDX_DMA_INFO_VAR(var) do{ \
	if(xdx_get_vdma_dbglevel() >= 4) \
		pr_info(#var"=0x%x\n", (uint32_t)var); \
}while(0)

#define XDX_DMA_INFO_VAR64(var) do{ \
	if(xdx_get_vdma_dbglevel() >= 4) \
		pr_info(#var"=0x%llx\n", (uint64_t)var); \
}while(0)


void xdx_vdma_print_regs(PVRSRV_DEVICE_NODE *psDevNode);
uint32_t xdx_get_vdma_dbglevel(void);

void xdx_set_vdma_dbglevel(uint32_t value);


void xdx_vdma_dbglevel_init(void);


#endif
