/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
//#define DEBUG
#include <linux/interrupt.h>
#include <linux/delay.h>
#include <linux/moduleparam.h>
#include <linux/version.h>
#include <linux/dma-mapping.h>

#include "sysinfo.h"
//#include "pangu_drv.h"
#include "xdx_dma.h"
#include "B0_HalVdma.h"

#include "pangu.h"
#include "virt-dma.h"

#include "pvrmodule.h"
//#include <linux/platform_device.h>
#include <linux/dma-mapping.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/mm.h>
#include <linux/device.h>
#include <linux/dmaengine.h>
#include <linux/hardirq.h>
#include <linux/spinlock.h>
#include <linux/percpu.h>
#include <linux/rcupdate.h>
#include <linux/mutex.h>
#include <linux/jiffies.h>
#include <linux/rculist.h>
#include <linux/idr.h>
#include <linux/slab.h>
#include <linux/acpi.h>
#include <linux/acpi_dma.h>
#include <linux/of_dma.h>
#include <linux/mempool.h>
#include <linux/numa.h>
#include <linux/mod_devicetable.h>
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 11, 0))
#include <linux/dma-map-ops.h>
#endif

#if (LINUX_VERSION_CODE < KERNEL_VERSION(5, 11, 0))
#include <linux/gfp.h>
#endif
#include <linux/highmem.h>
#include "osfunc.h"
#include "hash.h"
#include "pvr_debug.h"
#include "dma_drv_common.h"
#include "generated/volcanic/dma_bridge/common_dma_bridge.h"

#include <linux/dmaengine.h>
#include <linux/delay.h>

#include "dma_debug.h"
#include "xdx_device.h"
#include "xdx_dma_drv.h"
#include "xdx_drv.h"
#include "syscommon.h"
#include "HalTDMA.h"

static void xdx_set_burst_length(u32 *p_cfg, s8 src_burst, s8 dst_burst);

struct xdx_dma_pchan_cfg vdma_b0_pchans[] = {
//	{.chan_id = DMA_CHAN_ID(0, 0), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(0, 1), .prio = 0,},
	{.chan_id = DMA_CHAN_ID(0, 2), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(0, 3), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 0), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 1), .prio = 0,},
	{.chan_id = DMA_CHAN_ID(1, 2), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 3), .prio = 0,},
};

const u32 vdma_b0_pchans1[] = {
//	DMA_CHAN_ID(0,0),
//	DMA_CHAN_ID(0,1),
	DMA_CHAN_ID(0,2),
//	DMA_CHAN_ID(0,3),
//	DMA_CHAN_ID(1,0),
//	DMA_CHAN_ID(1,1),
	DMA_CHAN_ID(1,2),
//	DMA_CHAN_ID(1,3),
};

const u32 tdma_b0_lenunit_bpps[] =
	{ 8, 16, 32, 48, 64, 96, 128};

struct xdx_dma_vchan_cfg vdma_b0_vchans[] = {
	{
		.dev_id = 0,
		.prio = -1,
		.num_pchan = ARRAY_SIZE(vdma_b0_pchans1),
		.pchans = vdma_b0_pchans1,
	},
};
#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 10, 0)
static struct dma_slave_map xdx_vdmab0_map[] = {
	{.devname = "xdx_vdma", .slave = "xdx_dma",.param = "xdx_vdma"},
};
#endif
struct xdx_dma_drv_cfg xdxvdma_b0 = {
	.set_burst_length = xdx_set_burst_length,
	.src_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.dst_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.flags = XDXDMA_FLAG_VDMA | XDXDMA_FLAG_B0,
	.num_vchan = ARRAY_SIZE(vdma_b0_vchans),
	.vchans = vdma_b0_vchans,
	.num_pchan = ARRAY_SIZE(vdma_b0_pchans),
	.pchans = vdma_b0_pchans,
#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 10, 0)
	.fn_map = xdx_vdmab0_map,
#endif
	.desc_entry_size = VDMA_B0_DESC_DATA_SIZE,
};

struct xdx_dma_pchan_cfg tdma_b0_pchans[] = {
	{.chan_id = DMA_CHAN_ID(0, 0), .prio = 0,},
};

const u32 tdma_b0_pchans1[] = {
	DMA_CHAN_ID(0,0),
};

struct xdx_dma_vchan_cfg tdma_b0_vchans[] = {
	{
		.dev_id = 0,
		.prio = -1,
		.num_pchan = ARRAY_SIZE(tdma_b0_pchans1),
		.pchans = tdma_b0_pchans1,
	},
};
#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 10, 0)
static struct dma_slave_map xdx_tdmab0_map[] = {
	{.devname = "xdx_tdma", .slave = "xdx_twiddle_dma",.param = "xdx_tdma"},
};
#endif
struct xdx_dma_drv_cfg xdxtdma_b0 = {
	.set_burst_length = xdx_set_burst_length,
	.src_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.dst_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.flags = XDXDMA_FLAG_TDMA | XDXDMA_FLAG_B0,
	.num_vchan = ARRAY_SIZE(tdma_b0_vchans),
	.vchans = tdma_b0_vchans,
	.num_pchan = ARRAY_SIZE(tdma_b0_pchans),
	.pchans = tdma_b0_pchans,
#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 10, 0)
	.fn_map = xdx_tdmab0_map,
#endif
	.desc_entry_size = VDMA_B0_DESC_DATA_SIZE,
};

static void xdx_set_burst_length(u32 *p_cfg, s8 src_burst, s8 dst_burst)
{

}

static bool xdx_dma_xmit_2d_check(DMA_XMIT_2D_PARA *twd_2d_para)
{
	int i;

	if (twd_2d_para->Width < 4 || twd_2d_para->Height < 4)
		return false;
	if (twd_2d_para->Width > (1 << 15) || twd_2d_para->Height > (1 << 15))
		return false;
	if (twd_2d_para->XStride < twd_2d_para->Width)
		return false;
	for (i = 0; i < ARRAY_SIZE(tdma_b0_lenunit_bpps); i++) {
		if (tdma_b0_lenunit_bpps[i] == twd_2d_para->LenUnit)
			return true;
	}
	return false;
}


static bool xdx_dma_twiddle_2d_check(DMA_TWD_2D3D_PARA *twd_2d_para)
{
	int i;

	if (twd_2d_para->Width < 4 || twd_2d_para->Height < 4)
		return false;
	if (twd_2d_para->Width > (1 << 15) || twd_2d_para->Height > (1 << 15))
		return false;
	if (twd_2d_para->XStride < twd_2d_para->Width)
		return false;
	for (i = 0; i < ARRAY_SIZE(tdma_b0_lenunit_bpps); i++) {
		if (tdma_b0_lenunit_bpps[i] == twd_2d_para->LenUnit)
			return true;
	}
	return false;
}

static bool xdx_dma_twiddle_3d_check(DMA_TWD_2D3D_PARA *twd_3d_para)
{
	int i;

	if (twd_3d_para->Width < 4 || twd_3d_para->Height < 4 || twd_3d_para->Depth < 4)
		return false;
	if (twd_3d_para->Width > (1 << 15) || twd_3d_para->Height > (1 << 15) || twd_3d_para->Depth > (1 << 11))
		return false;

	if (twd_3d_para->XStride < twd_3d_para->Width)
		return false;
	if (twd_3d_para->YStride < (twd_3d_para->XStride * twd_3d_para->Height))
		return false;
	for (i = 0; i < ARRAY_SIZE(tdma_b0_lenunit_bpps); i++) {
		if (tdma_b0_lenunit_bpps[i] == twd_3d_para->LenUnit)
			return true;
	}
	return false;
}

static bool xdx_dma_twiddle_2d3d_check(DMA_TWD_2D3D_PARA *twd_2d3d_para)
{
	if (twd_2d3d_para->CmdType == XdxDmaTypeTWD2D)
		return xdx_dma_twiddle_2d_check(twd_2d3d_para);
	else
		return xdx_dma_twiddle_3d_check(twd_2d3d_para);
}

static bool xdx_tdma_para_check_b0(
	struct xdx_dma_dev *sdev, xdx_dma_xmit_type_e xmit_type, void *para)
{
	switch (xmit_type) {
	case XDX_XMIT_COPY_2D:
		return xdx_dma_xmit_2d_check((DMA_XMIT_2D_PARA *)para);
	case XDX_XMIT_TWD_2D3D:
		return xdx_dma_twiddle_2d3d_check((DMA_TWD_2D3D_PARA *)para);
	default:
	break;
	}
	return true;
}

static int xdx_tdma_lenunit_get_b0(uint16_t LenUnit)
{
	int i;

	for (i = 0; i < ARRAY_SIZE(tdma_b0_lenunit_bpps); i++) {
		if (tdma_b0_lenunit_bpps[i] == LenUnit)
			return i;
	}
	return 0;
}
static VDMA_B0_DescData_T *xdx_vdma_alloc_desc_entry_b0(struct xdx_dma_dev *sdev,
		struct list_head *list,uint64_t data_size, bool linkend)
{
	dma_addr_t p_desc_blk;
	xdx_dma_desc_blk_t *desc_blk;
	xdx_dma_desc_blk_t *desc_blk_temp;
	struct list_head *desc_nexthead;
	VDMA_B0_DescData_T *desc_data;

	if (list_empty(list)) {
		desc_blk = alloc_desc_block(sdev, &p_desc_blk);
		if (!desc_blk)
			return ERR_PTR(-ENOMEM);
		list_add_tail(&desc_blk->list, list);
	}
	desc_blk = list_last_entry(list, xdx_dma_desc_blk_t, list);
	desc_nexthead = &desc_blk->next_list;
retry:
	desc_blk = list_last_entry(desc_nexthead, xdx_dma_desc_blk_t, next_list);
	if (linkend) {
		if (desc_blk->desc_num == 0) {
			XDX_DMA_ERR(sdev->dev, "linkend descriptor blk has no data.");
			return ERR_PTR(-EINVAL);
		}
		VDMA_B0_GenEndVdmaDesc(0ULL, 0, 1,
			(VDMA_B0_DescData_T *)xdx_dma_get_desc_entry(sdev, desc_blk, desc_blk->desc_num));
		XDX_DMA_DBG(sdev->dev, "Pad Linkend to %d/%d.", desc_blk->desc_num, desc_blk->desc_total);
		return (VDMA_B0_DescData_T *)xdx_dma_get_desc_entry(sdev, desc_blk, desc_blk->desc_num++);
	}
	if (desc_blk->desc_num < desc_blk->desc_total -1) {
		if (!list_empty(desc_nexthead)) {
			desc_blk_temp = list_prev_entry(desc_blk, next_list);
			VDMA_B0_GenEndVdmaDesc(desc_blk->desc_addr + offsetof(xdx_dma_desc_blk_t, desc_entry),
					desc_blk->desc_num + 2, 0,
					(VDMA_B0_DescData_T *)xdx_dma_get_desc_entry(sdev, desc_blk_temp, desc_blk_temp->desc_total -1));
			if(desc_blk->desc_num == desc_blk->desc_total - 2)
				XDX_DMA_DBG(sdev->dev, "Next:%d Pad prev desc block to %d/%d.",
					desc_blk->desc_num + 2, desc_blk_temp->desc_num, desc_blk_temp->desc_total -1);
		} else {
//			pr_debug("No Pad first desc block %d.", desc_blk->desc_num);
		}
		desc_blk_temp = list_entry(desc_nexthead, xdx_dma_desc_blk_t, next_list);
		desc_blk_temp->data_size += data_size;
		desc_data = xdx_dma_get_desc_entry(sdev, desc_blk,  desc_blk->desc_num++);
		return desc_data;
	}
	desc_blk->desc_num++;
	desc_blk_temp =  alloc_desc_block(sdev, &p_desc_blk);
	if (!desc_blk_temp)
		return ERR_PTR(-ENOMEM);
	list_add_tail(&desc_blk_temp->next_list, desc_nexthead);
	XDX_DMA_DBG(sdev->dev, "Add Next Desc.");
	goto retry;
}

static int xdx_vdma_pad_desc_end_b0(struct xdx_dma_dev *sdev, struct list_head *list)
{
	VDMA_B0_DescData_T *desc_entry;
	desc_entry = xdx_vdma_alloc_desc_entry_b0(sdev, list, 0, 1);
	if (IS_ERR_OR_NULL(desc_entry))
		return -ENOMEM;
	return 0;
}

static VDMA_B0_DescData_T *xdx_vdma_new_desc_list_b0(struct xdx_dma_dev *sdev,
		struct list_head *list, uint64_t data_size)
{
	dma_addr_t p_desc_blk;
	xdx_dma_desc_blk_t *desc_blk;

	if (!list_empty(list)) {
		xdx_vdma_pad_desc_end_b0(sdev, list);
	}
	desc_blk = alloc_desc_block(sdev, &p_desc_blk);
	if (!desc_blk)
		return ERR_PTR(-ENOMEM);
	list_add_tail(&desc_blk->list, list);
	return xdx_vdma_alloc_desc_entry_b0(sdev, list, data_size, 0);
}

static int xdx_vdma_desc_entry_add_b0(
	struct xdx_dma_dev *sdev,
	struct list_head *list,
	dma_addr_t blk_addr,
	uint64_t lens,
	bool new_blk)
{
	VDMA_B0_DescData_T *desc_entry;
	uint64_t seg_lens;
	uint64_t remain_size = lens;
	uint64_t offset = 0;

	do {
		seg_lens = remain_size;
		if (remain_size < VDMA_MAX_SIZE_SL_8B) {
			seg_lens = remain_size;
		} else if (MOD_2(remain_size, VDMA_ADDR_BEST_ALIGN)) {
			seg_lens = MOD_2(remain_size, VDMA_ADDR_BEST_ALIGN);
		}
		seg_lens = MIN(seg_lens, VDMA_MAX_SIZE_SL_1K);

		if (!new_blk) {
			desc_entry = xdx_vdma_alloc_desc_entry_b0(sdev, list, seg_lens, 0);
			if (IS_ERR_OR_NULL(desc_entry))
				return -ENOMEM;
		} else {
			desc_entry = xdx_vdma_new_desc_list_b0(sdev, list, seg_lens);
			if (IS_ERR_OR_NULL(desc_entry))
				return -ENOMEM;
		}
		if (MOD_2(seg_lens, VDMA_ADDR_BEST_ALIGN)) {
			VDMA_B0_GenNonEndVdmaDesc(blk_addr  + offset,
				seg_lens >> VDMA_DRV_LENUNIT_8B_SHIFT, VDMA_B0_LENUNIT_8B, desc_entry);
		} else {
			VDMA_B0_GenNonEndVdmaDesc(blk_addr + offset,
				seg_lens >> VDMA_DRV_LENUNIT_1K_SHIFT, VDMA_B0_LENUNIT_1K, desc_entry);
		}
		offset += seg_lens;
		remain_size -= seg_lens;
		new_blk = 0;
	} while (offset < lens);
	return 0;
}

static int xdx_dma_parse_sgl_b0(struct xdx_dma_dev *sdev,
	xdxdma_xmit_sg_t *sgt, struct list_head *list, uint64_t data_size, bool unit_ignor)
{
	struct scatterlist *sg;
	int ret;
	int i;
	uint64_t remain_len;
	uint64_t offset = 0;
	uint32_t blk_len;
	uint32_t seg_len;
	uint32_t align_size;
	bool need_switch_desc = 0;
	dma_addr_t blk_addr;

	if (!sgt->sgl || ! sgt->sg_len)
		return -EINVAL;
	remain_len = data_size;
	align_size = MOD_2(data_size, VDMA_ADDR_BEST_ALIGN);
	for_each_sg(sgt->sgl, sg, sgt->sg_len, i) {
		blk_len = sg_dma_len(sg);
		blk_addr = sg_dma_address(sg);
		if (blk_len == 0)
			continue;
		if (unit_ignor) {
			ret = xdx_vdma_desc_entry_add_b0(sdev, list, blk_addr, blk_len, 0);
			if (ret < 0)
				return ret;
		} else {
			while (blk_len && remain_len) {
				if (data_size <= VDMA_MAX_SIZE_SL_8B) {
					seg_len = MIN(remain_len, blk_len);
				} else {
					if (offset < align_size) {
						seg_len = MIN(align_size - offset, blk_len);
					} else {
						seg_len = MIN(VDMA_MAX_SIZE_SL_1K - (offset & (VDMA_MAX_SIZE_SL_1K -1)) + align_size, blk_len);
						if (seg_len != blk_len)
							XDX_DMA_DBG(sdev->dev, "[%s] NextSwitch DataSize:%llx to offset:%llx blk_len:%x seg_len:%x:",
								__func__, data_size, offset, blk_len, seg_len);
						if (((offset - align_size) & (VDMA_MAX_SIZE_SL_1K -1)) == 0) {
							need_switch_desc = 1;
							XDX_DMA_DBG(sdev->dev, "[%s] DataSize:%llx to offset:%llx blk_len:%x seg_len:%x  switch",
								__func__, data_size, offset, blk_len, seg_len);
						}
					}
				}
				ret = xdx_vdma_desc_entry_add_b0(sdev, list, blk_addr, seg_len, need_switch_desc);
				if (ret < 0)
					return ret;
				blk_len -= seg_len;
				remain_len -= seg_len;
				offset += seg_len;
				blk_addr += seg_len;
				need_switch_desc = 0;
			}
		}
	}
	ret = xdx_vdma_pad_desc_end_b0(sdev, list);
	return ret;
}

const static int unit_shift_tab[5] = {3, 4, 5, 6, 10};
static inline int xdx_dma_calc_xmit_len(uint8_t unit, uint32_t unit_cnt)
{
	if  (unit > 5)
		return -EINVAL;
	return unit_cnt << unit_shift_tab[unit];
}

static inline int xdx_dma_get_addr_mode(
		enum dma_transfer_direction dir,uint8_t *src_mode, uint8_t *dst_mode)
{
	switch (dir) {
		case DMA_MEM_TO_DEV:
			*src_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_HOST_VA);
			*dst_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_GPU_PA);
			break;
		case DMA_DEV_TO_MEM:
			*src_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_GPU_PA);
			*dst_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_HOST_VA);
			break;
		case DMA_DEV_TO_DEV:
			*src_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_GPU_PA);
			*dst_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_GPU_PA);
			break;
		case DMA_MEM_TO_MEM:
			*src_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_HOST_VA);
			*dst_mode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_HOST_VA);
			break;
		default:
			return -EINVAL;
	}
	return 0;
}
static inline int xdx_dma_cmd_cfg_init(
		struct xdx_desc *txd, VDMA_B0_CmdCfg_T *VdmaCfg)
{
	VdmaCfg->IntrEn = 1;
	VdmaCfg->PcieFuncNum = 0;
#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
	VdmaCfg->PcieDontSnoop = 1;
#endif
	return 0;
}

static int  xdx_dma_package_d2d_copy_cfg(
	struct xdx_dma_dev *sdev, struct xdx_desc *txd,
	dma_addr_t src, dma_addr_t dest, uint8_t unit,
	uint32_t unit_cnt)
{
	xdx_desc_cmd_cfg_t *cfg;
	VDMA_B0_CmdCfg_T *VdmaCfg;

	cfg = xdx_dma_alloc_cmd_cfg(sdev);
	if (!cfg)
		return -ENOMEM;
	VdmaCfg = &cfg->vb0_cfg;
	memset(VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));
	xdx_dma_cmd_cfg_init(txd, VdmaCfg);

	VdmaCfg->OpCode = VDMA_DRV_OPCODE_COPY_DSRC_DDST;
	VdmaCfg->copy.DstAddr = dest;
	VdmaCfg->copy.SrcAddr = src;
	xdx_dma_get_addr_mode(txd->direct, &VdmaCfg->copy.SrcAddrMode, &VdmaCfg->copy.DstAddrMode);
	VdmaCfg->copy.LenUnit = unit;
	VdmaCfg->copy.TransferLen = unit_cnt;
	XDX_DMA_DBG(sdev->dev, "[%s] opcode:%x src:%llx dst:%llx TransferLen:%x LenUnit:%d", __func__,
		VdmaCfg->OpCode, VdmaCfg->copy.SrcAddr, VdmaCfg->copy.DstAddr, VdmaCfg->copy.TransferLen,
		VdmaCfg->copy.LenUnit);
	list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
	atomic_inc(&txd->cmd_cnt);
	return xdx_dma_calc_xmit_len(unit, unit_cnt);
}

static int  xdx_dma_package_d2l_l2d_copy_cfg(
	struct xdx_dma_dev *sdev, struct xdx_desc *txd,
	dma_addr_t dma_addr, xdx_dma_desc_blk_t *desc_blk, bool src_dma)
{
	xdx_desc_cmd_cfg_t *cfg;
	VDMA_B0_CmdCfg_T *VdmaCfg;
//	xdx_dma_desc_blk_t *tdesc_blk = desc_blk;

	cfg = xdx_dma_alloc_cmd_cfg(sdev);
	if (!cfg)
		return -ENOMEM;
	xdx_dma_flush_desc_block(sdev, txd, desc_blk);
	VdmaCfg = &cfg->vb0_cfg;

	memset(VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));
	xdx_dma_cmd_cfg_init(txd, VdmaCfg);

	if (src_dma) {
		VdmaCfg->OpCode = VDMA_B0_OPCODE_COPY_DSRC_LDST;
		VdmaCfg->copy.SrcAddr = dma_addr;
		VdmaCfg->copy.DstAddr = desc_blk->desc_addr + offsetof(xdx_dma_desc_blk_t, desc_entry);
		VdmaCfg->copy.DstDescNum = desc_blk->desc_num;
	} else {
		VdmaCfg->OpCode = VDMA_B0_OPCODE_COPY_LSRC_DDST;
		VdmaCfg->copy.SrcAddr = desc_blk->desc_addr+ offsetof(xdx_dma_desc_blk_t, desc_entry);
		VdmaCfg->copy.SrcDescNum = desc_blk->desc_num;
		VdmaCfg->copy.DstAddr = dma_addr;
	}
	xdx_dma_get_addr_mode(txd->direct, &VdmaCfg->copy.SrcAddrMode, &VdmaCfg->copy.DstAddrMode);

	if ((desc_blk->data_size & 0X3FF)) {
		VdmaCfg->copy.LenUnit = VDMA_B0_LENUNIT_8B;
		VdmaCfg->copy.TransferLen = desc_blk->data_size >> VDMA_DRV_LENUNIT_8B_SHIFT;
	} else {
		VdmaCfg->copy.LenUnit = VDMA_B0_LENUNIT_1K;
		VdmaCfg->copy.TransferLen = desc_blk->data_size >> VDMA_DRV_LENUNIT_1K_SHIFT;
	}
	XDX_DMA_DBG(sdev->dev, "[%s] opcode:%x src:%llx dst:%llx SrcDescNum:%d DstDescNum:%d LenUnit:%d TransferLen:%x data_size:%llx", __func__,
		VdmaCfg->OpCode, VdmaCfg->copy.SrcAddr, VdmaCfg->copy.DstAddr, VdmaCfg->copy.SrcDescNum,
		VdmaCfg->copy.DstDescNum,VdmaCfg->copy.LenUnit, VdmaCfg->copy.TransferLen, desc_blk->data_size);
	list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
	atomic_inc(&txd->cmd_cnt);
	return desc_blk->data_size;
}

static int  xdx_dma_package_l2l_copy_cfg(
	struct xdx_dma_dev *sdev, struct xdx_desc *txd,
	xdx_dma_desc_blk_t *desc_blk_src, xdx_dma_desc_blk_t *desc_blk_dest)
{
	xdx_desc_cmd_cfg_t *cfg;
	VDMA_B0_CmdCfg_T *VdmaCfg;

	cfg = xdx_dma_alloc_cmd_cfg(sdev);
	if (!cfg)
		return -ENOMEM;
	xdx_dma_flush_desc_block(sdev, txd, desc_blk_src);
	xdx_dma_flush_desc_block(sdev, txd, desc_blk_dest);

	VdmaCfg = &cfg->vb0_cfg;
	memset(VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));
	xdx_dma_cmd_cfg_init(txd, VdmaCfg);

	VdmaCfg->OpCode = VDMA_B0_OPCODE_COPY_LSRC_LDST;
	VdmaCfg->copy.SrcAddr = desc_blk_src->desc_addr + offsetof(xdx_dma_desc_blk_t, desc_entry);
	VdmaCfg->copy.DstAddr = desc_blk_dest->desc_addr + offsetof(xdx_dma_desc_blk_t, desc_entry);
	VdmaCfg->copy.SrcDescNum = desc_blk_src->desc_num;
	VdmaCfg->copy.DstDescNum = desc_blk_dest->desc_num;
	xdx_dma_get_addr_mode(txd->direct, &VdmaCfg->copy.SrcAddrMode, &VdmaCfg->copy.DstAddrMode);
	XDX_DMA_DBG(sdev->dev, "[%s] opcode:%x src:%llx dst:%llx SrcDescNum:%d DstDescNum:%d", __func__,
		VdmaCfg->OpCode, VdmaCfg->copy.SrcAddr, VdmaCfg->copy.DstAddr, VdmaCfg->copy.SrcDescNum,
		VdmaCfg->copy.DstDescNum);
	list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
	atomic_inc(&txd->cmd_cnt);
	return txd->paras.len;
}

static int xdx_dma_package_copy2d_cfg(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	xdx_desc_cmd_cfg_t *cfg;
	VDMA_B0_CmdCfg_T *VdmaCfg;

	cfg = xdx_dma_alloc_cmd_cfg(sdev);
	if (!cfg)
		return -ENOMEM;
	VdmaCfg = &cfg->vb0_cfg;
	memset(VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));

	VdmaCfg->OpCode = VDMA_B0_OPCODE_2DCOPY;
	xdx_dma_cmd_cfg_init(txd, VdmaCfg);
	VdmaCfg->copy2d.SrcAddr = txd->paras.src.addr;
	VdmaCfg->copy2d.DstAddr = txd->paras.dest.addr;
	VdmaCfg->copy2d.LenUnit = VDMA_B0_LENUNIT_8B;
	VdmaCfg->copy2d.Sstride = txd->paras.para_2d.x_stride >> VDMA_DRV_LENUNIT_8B_SHIFT;
//	VdmaCfg->copy2d.Dstride = txd->paras.para_2d.Dststride>> VDMA_DRV_LENUNIT_8B_SHIFT;
	VdmaCfg->copy2d.Xstep = txd->paras.para_2d.width >> VDMA_DRV_LENUNIT_8B_SHIFT;
	VdmaCfg->copy2d.Ystep = txd->paras.para_2d.height;
	xdx_dma_get_addr_mode(txd->direct, &VdmaCfg->copy2d.SrcAddrMode, &VdmaCfg->copy2d.DstAddrMode);

	XDX_DMA_DBG(sdev->dev, "[%s] opcode:%d src:%llx dst:%llx LenUnit:%d ,Sstride:%x, Dstride:%x, Xstep:%x, Ystep:%x",
		__func__, VdmaCfg->OpCode, VdmaCfg->copy2d.SrcAddr, VdmaCfg->copy2d.DstAddr, VdmaCfg->copy2d.LenUnit,
		VdmaCfg->copy2d.Sstride, VdmaCfg->copy2d.Dstride, VdmaCfg->copy2d.Xstep, VdmaCfg->copy2d.Ystep);

	list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
	atomic_inc(&txd->cmd_cnt);
	return txd->paras.para_2d.width * txd->paras.para_2d.height;
}

static int xdx_dma_package_copy2d3d_cfg(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	xdx_desc_cmd_cfg_t *cfg;
	TDMA_CmdCfg_T *TdmaCfg;

	cfg = xdx_dma_alloc_cmd_cfg(sdev);
	if (!cfg)
		return -ENOMEM;
	TdmaCfg = &cfg->tb0_cfg;
	memset(TdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));
	TdmaCfg->IntrEn = 1;

#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
	TdmaCfg->DontSnoop = 1;
#endif
	TdmaCfg->SrcAddr = txd->paras.src.addr;
	TdmaCfg->DstAddr = txd->paras.dest.addr;
	TdmaCfg->Xstep = txd->paras.twiddle_2d3d.width;
	TdmaCfg->Ystep = txd->paras.twiddle_2d3d.height;
	TdmaCfg->Zstep = txd->paras.twiddle_2d3d.depth;
	TdmaCfg->Xstride = txd->paras.twiddle_2d3d.x_stride;
	TdmaCfg->Ystride = txd->paras.twiddle_2d3d.y_stride;
	TdmaCfg->LenUnit = xdx_tdma_lenunit_get_b0(txd->paras.twiddle_2d3d.len_unit);
	if (TdmaCfg->Zstep == 1)
		TdmaCfg->Opcode = TDMA_OPCODE_2DCOPY;
	else
		TdmaCfg->Opcode = TDMA_OPCODE_3DCOPY;

	switch (txd->direct) {
	case DMA_MEM_TO_DEV:
		TdmaCfg->SrcAddrMode = TDMA_SRCADDRMODE_HOST_VA;
		TdmaCfg->DstAddrMode = txd->paras.dest.addr_flag & XDX_DMA_ADDR_SUPSMMU ?
			TDMA_DSTADDRMODE_GPU_VA : TDMA_DSTADDRMODE_GPU_PA;
	break;
	case DMA_DEV_TO_DEV:
		TdmaCfg->SrcAddrMode = txd->paras.src.addr_flag & XDX_DMA_ADDR_SUPSMMU ?
			TDMA_SRCADDRMODE_GPU_VA : TDMA_SRCADDRMODE_GPU_PA;
		TdmaCfg->DstAddrMode = txd->paras.dest.addr_flag & XDX_DMA_ADDR_SUPSMMU ?
			TDMA_DSTADDRMODE_GPU_VA : TDMA_DSTADDRMODE_GPU_PA;
		break;
	case DMA_MEM_TO_MEM:
	case DMA_DEV_TO_MEM:
	default:
		return -EINVAL;
	}

	XDX_DMA_DBG(sdev->dev,
		"3Dop:%d src:%llx dst:%llx Lu:%d ,Xstr:%x, Ystr:%llx,"
		" Xtp:%x, Ytp:%x, Ztp:%x SM:%x DM:%x",
		TdmaCfg->Opcode, TdmaCfg->SrcAddr,
		TdmaCfg->DstAddr, TdmaCfg->LenUnit,
		TdmaCfg->Xstride, TdmaCfg->Ystride,
		TdmaCfg->Xstep, TdmaCfg->Ystep, TdmaCfg->Zstep,
		TdmaCfg->SrcAddrMode, TdmaCfg->DstAddrMode);
	list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
	atomic_inc(&txd->cmd_cnt);
	return txd->paras.twiddle_2d3d.width * txd->paras.twiddle_2d3d.height * txd->paras.twiddle_2d3d.depth;
}

static int xdx_vdma_package_copy_cfg_b0(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	uint64_t remain_len;
	xdx_dma_desc_blk_t *desc_blk;
	uint64_t offset = 0;
	int copy_size = 0;

	if (txd->paras.src.addr_type == XDX_DMA_ADDR_SGL &&
		txd->paras.dest.addr_type == XDX_DMA_ADDR_SGL) {
		copy_size = xdx_dma_package_l2l_copy_cfg(sdev, txd,
				list_first_entry(&txd->desc_src_head, xdx_dma_desc_blk_t, list),
				list_first_entry(&txd->desc_dest_head, xdx_dma_desc_blk_t, list));
		if (copy_size <= 0)
			return copy_size;
	} else if (txd->paras.src.addr_type == XDX_DMA_ADDR_SGL) {
		offset = 0;
		if (txd->paras.dest.addr_type == XDX_DMA_ADDR_NULL) {
			txd->paras.dest.addr = txd->vd.tx.phys;
			txd->paras.dest.addr_type = XDX_DMA_ADDR_DMA;
		}
		list_for_each_entry(desc_blk, &txd->desc_src_head, list) {
			copy_size = xdx_dma_package_d2l_l2d_copy_cfg(sdev, txd, txd->paras.dest.addr + offset, desc_blk, 0);
			if (copy_size <= 0)
				return copy_size;
			offset += copy_size;
			XDX_DMA_DBG(sdev->dev, "Dest:%llx Offset:%llx  ->%llx", txd->paras.dest.addr, offset, txd->paras.dest.addr + offset);
		}
		XDX_DMA_DBG(sdev->dev, "L2D Copy Size:%llx --%llx", offset, txd->paras.len);
	} else if (txd->paras.dest.addr_type == XDX_DMA_ADDR_SGL) {
		offset = 0;
		if (txd->paras.src.addr_type == XDX_DMA_ADDR_NULL) {
			txd->paras.src.addr = txd->vd.tx.phys;
			txd->paras.src.addr_type = XDX_DMA_ADDR_DMA;
		}
		list_for_each_entry(desc_blk, &txd->desc_dest_head, list) {
			copy_size = xdx_dma_package_d2l_l2d_copy_cfg(sdev, txd, txd->paras.src.addr + offset, desc_blk, 1);
			if (copy_size <= 0)
				return copy_size;
			offset += copy_size;
			XDX_DMA_DBG(sdev->dev, "Src:%llx Offset:%llx  ->%llx", txd->paras.src.addr, offset, txd->paras.src.addr + offset);
		}
		XDX_DMA_DBG(sdev->dev, "D2L Copy Size:%llx --%llx", offset, txd->paras.len);
	} else {
		offset = 0;
		remain_len = txd->paras.len;
		if (remain_len <= VDMA_MAX_SIZE_SL_8B) {
			copy_size = xdx_dma_package_d2d_copy_cfg(sdev, txd, txd->paras.src.addr,
					txd->paras.dest.addr, VDMA_B0_LENUNIT_8B, remain_len >> VDMA_DRV_LENUNIT_8B_SHIFT);
			if (copy_size <= 0)
				return copy_size;
		} else {
			copy_size = MOD_2(remain_len, VDMA_ADDR_BEST_ALIGN);
			if (copy_size) {
				copy_size = xdx_dma_package_d2d_copy_cfg(sdev, txd, txd->paras.src.addr,
					txd->paras.dest.addr, VDMA_B0_LENUNIT_8B, copy_size >> VDMA_DRV_LENUNIT_8B_SHIFT);
				if (copy_size <= 0)
					return copy_size;
				remain_len -= copy_size;
				offset += copy_size;
			}
			while(remain_len > 0) {
				copy_size = MIN(remain_len, VDMA_MAX_SIZE_SL_1K);
				copy_size = xdx_dma_package_d2d_copy_cfg(sdev, txd, txd->paras.src.addr + offset,
					txd->paras.dest.addr + offset, VDMA_B0_LENUNIT_1K, copy_size >> VDMA_DRV_LENUNIT_1K_SHIFT);
				if (copy_size <= 0)
					return copy_size;
				remain_len -= copy_size;
				offset += copy_size;
			}
		}
	}
	XDX_DMA_DBG(sdev->dev, "[%s] Srctype:%d,Dsttype:%d cmd_cnt:%d, copy_size:%x", __func__,
		txd->paras.src.addr_type, txd->paras.dest.addr_type, atomic_read(&txd->cmd_cnt), copy_size);
	return 0;
}

static int  _xdx_dma_package_memset_cfg_b0(struct xdx_dma_dev *sdev, struct xdx_desc *txd,
		uint64_t remain_len, dma_addr_t dstAddr)
{
	xdx_desc_cmd_cfg_t *cfg;
	VDMA_B0_CmdCfg_T *VdmaCfg;
	int copy_size = 0;
	uint64_t offset = 0;

	while (remain_len > 0) {
		copy_size = MIN(remain_len, VDMA_B0_XFERLEN_LIMIT * txd->paras.para_memset.Pattern_len);
		cfg = xdx_dma_alloc_cmd_cfg(sdev);
		if (!cfg)
			return -ENOMEM;
		VdmaCfg = &cfg->vb0_cfg;
		memset(VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));
		xdx_dma_cmd_cfg_init(txd, VdmaCfg);

		VdmaCfg->OpCode = VDMA_DRV_OPCODE_WRITE_DIRECT;
		VdmaCfg->dwrite.DstAddr = dstAddr + offset;
		if (txd->direct == DMA_MEM_TO_DEV) {
			VdmaCfg->dwrite.DstAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
		} else {
			VdmaCfg->dwrite.DstAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_HOST_VA, VDMA_B0_ADDRMODE_HOST_VA);
		}
		VdmaCfg->dwrite.TransferLen = copy_size >> VDMA_B0_REFBUF_OFFSET;
		VdmaCfg->dwrite.PatternLen = txd->paras.para_memset.Pattern_len;
		VdmaCfg->dwrite.patternData = txd->paras.para_memset.Pattern[0];
		XDX_DMA_DBG(sdev->dev, "[%s] opcode:%x dst:%llx TransferLen:%x PatternLen:%d  cmd_cnt:%d", __func__,
			VdmaCfg->OpCode,  VdmaCfg->dwrite.DstAddr, VdmaCfg->dwrite.TransferLen,
			VdmaCfg->dwrite.PatternLen, atomic_read(&txd->cmd_cnt));
		list_add_tail(&cfg->list, &txd->cmd_cfgs_head);
		atomic_inc(&txd->cmd_cnt);
		remain_len -= copy_size;
		offset += copy_size;
	}
	return 0;
}

static int  xdx_dma_package_memset_cfg_b0(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	struct scatterlist *sg;
	int iRet = 0, i = 0;

	for_each_sg(txd->paras.dest.sg_tab.sgl, sg, txd->paras.dest.sg_tab.sg_len, i) {
		if (sg_dma_len(sg) == 0)
			continue;
		iRet = _xdx_dma_package_memset_cfg_b0(sdev, txd, sg_dma_len(sg), sg_dma_address(sg));
		if (iRet < 0)
			return iRet;
	}
	return iRet;
}

static int xdx_dma_package_cfg_b0(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	int ret = 0;

	switch(txd->xmit_type) {
		case XDX_XMIT_COPY:
			ret = xdx_vdma_package_copy_cfg_b0(sdev, txd);
		break;
		case XDX_XMIT_COPY_2D:
			ret = xdx_dma_package_copy2d_cfg(sdev, txd);
		break;
		case XDX_XMIT_TWD_2D3D:
			ret = xdx_dma_package_copy2d3d_cfg(sdev, txd);
		break;
		case XDX_XMIT_MEMSET:
			ret = xdx_dma_package_memset_cfg_b0(sdev, txd);
		break;
		case XDX_XMIT_POLL:
		default:
			ret = -ENOTSUPP;
		break;
	}
	return ret;
}

static int xdx_dma_issue_tdma_b0 (
		struct xdx_vchan *vchan, struct xdx_desc *txd, xdx_desc_cmd_cfg_t *cfg)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vchan->vc.chan.device);
	struct xdx_pchan *pchan = NULL;
	TDMA_CmdData_T TdmaCmd;
	uint32_t cmd_tag;
	TDMA_CmdCfg_T *pTdmaCfg = &cfg->tb0_cfg;

	//Get_freeCommand
	cmd_tag = xdx_dma_request_command_tag(vchan, sdev, &txd->pchan_used);
	if (cmd_tag < 0 || txd->pchan_used == NULL)
		return -EBUSY;

	pchan = txd->pchan_used;
	pchan->cmdRef[cmd_tag].desc = txd; //record command reference in pchan struct
	pchan->cmdRef[cmd_tag].vchan = vchan; //record command reference in pchan struct
	pTdmaCfg->Tag = cmd_tag;
	TDMA_GenCmd(pTdmaCfg, &TdmaCmd);
	spin_lock(&pchan->lock);
	TDMA_WrCmdBuf((uint64_t)sdev->base, TdmaCmd.cmd64, 4);
	spin_unlock(&pchan->lock);
	return 0;
}

static int xdx_dma_issue_vdma_b0 (
		struct xdx_vchan *vchan, struct xdx_desc *txd,  xdx_desc_cmd_cfg_t *cfg)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vchan->vc.chan.device);
	struct xdx_pchan *pchan = NULL;
	VDMA_B0_CmdData_T VdmaCmd;
	int32_t cmd_tag;
	VDMA_B0_CmdCfg_T *pVdmaCfg = &cfg->vb0_cfg;
	//Get_freeCommand
	cmd_tag = xdx_dma_request_command_tag(vchan, sdev, &txd->pchan_used);
	if (cmd_tag < 0 || txd->pchan_used == NULL)
		return -EBUSY;
	pchan = txd->pchan_used;
	pchan->cmdRef[cmd_tag].desc = txd; //record command reference in pchan struct
	pchan->cmdRef[cmd_tag].vchan = vchan; //record command reference in pchan struct
	pVdmaCfg->CommandTag = cmd_tag;
	if(pVdmaCfg->OpCode == VDMA_DRV_OPCODE_WRITE_DIRECT) {
		VDMA_B0_ClrAndWrRefBufSingle((uint64_t)pchan->base, cmd_tag * VDMA_B0_REFBUF_OFFSET, pVdmaCfg->dwrite.patternData);
		pVdmaCfg->dwrite.PatternLoc = cmd_tag * VDMA_B0_REFBUF_OFFSET * pVdmaCfg->dwrite.PatternLen;
	}
	VDMA_B0_GenVdmaCmd(pVdmaCfg, &VdmaCmd);

	XDX_DMA_DBG(vchan->dev, "[%s]cookie:%d Isuue:%016llX %016llX %016llX", __func__, txd->vd.tx.cookie,
			VdmaCmd.dw0.all, VdmaCmd.dw1.all, VdmaCmd.dw2.all);
	VDMA_B0_DumpVdmaCmd(&VdmaCmd);
	spin_lock(&pchan->lock);
	VDMA_B0_WrCmdBuf((IMG_UINT64)pchan->base, VdmaCmd.cmd64, 3);
	spin_unlock(&pchan->lock);
	return 0;
}

static int  xdx_dma_parse_sgls_b0(struct xdx_dma_dev *sdev, struct xdx_desc *txd)
{
	int ret;

	if (txd->paras.src.addr_type == XDX_DMA_ADDR_SGL && txd->paras.dest.addr_type == XDX_DMA_ADDR_SGL) {
		ret = xdx_dma_parse_sgl_b0(sdev, &txd->paras.src.sg_tab, &txd->desc_src_head, txd->paras.len, 1);
		if (ret < 0)
			return ret;
		ret = xdx_dma_parse_sgl_b0(sdev, &txd->paras.dest.sg_tab, &txd->desc_dest_head, txd->paras.len, 1);
		if (ret < 0)
			return ret;
	} else if (txd->paras.src.addr_type == XDX_DMA_ADDR_SGL) {
		ret = xdx_dma_parse_sgl_b0(sdev, &txd->paras.src.sg_tab, &txd->desc_src_head, txd->paras.len, 0);
		if (ret < 0)
			return ret;
	} else if (txd->paras.dest.addr_type == XDX_DMA_ADDR_SGL) {
		ret = xdx_dma_parse_sgl_b0(sdev, &txd->paras.dest.sg_tab, &txd->desc_dest_head, txd->paras.len, 0);
		if (ret < 0)
			return ret;
	}
	return 0;
}

static void xdx_dma_reset_b0(struct xdx_dma_dev *sdev)
{
	// TODO
	XDX_DMA_ERR(sdev->dev, " dma ctrl need reset.");
}

static void xdx_dma_interrupt_cmdcmpl_b0(struct xdx_pchan *pchan, uint64_t CmdCmplRawSts)
{
	struct xdx_vchan *vchan;
	struct xdx_desc	*txd;
	uint32_t cmd_tag;

	while (CmdCmplRawSts) {
		cmd_tag = GetLeadOnefromU64(CmdCmplRawSts);
		BIT_UNSET(CmdCmplRawSts, cmd_tag);
		txd = pchan->cmdRef[cmd_tag].desc;
		vchan = pchan->cmdRef[cmd_tag].vchan;

		spin_lock(&pchan->lock);
		xdx_dma_release_command_tag(pchan, cmd_tag);
		spin_unlock(&pchan->lock);
		if (txd && atomic_dec_and_test(&txd->cmd_cnt)) {
			spin_lock(&vchan->vc.lock);
			xdx_vchan_cookie_complete(&txd->vd);
			spin_unlock(&vchan->vc.lock);
		}
	}
}

static void xdx_dma_interrupt_pollingtimeout_b0(struct xdx_dma_dev *sdev, struct xdx_pchan *pchan,
					unsigned int i, uint64_t PollingTimeoutRawSts)
{
	struct xdx_vchan *vchan;
	struct xdx_desc *txd;
	uint32_t cmd_tag;

	while (PollingTimeoutRawSts) {
		cmd_tag = GetLeadOnefromU64(PollingTimeoutRawSts);
		BIT_UNSET(PollingTimeoutRawSts, cmd_tag);

		txd = pchan->cmdRef[cmd_tag].desc;
		vchan = pchan->cmdRef[cmd_tag].vchan;

		if (txd && atomic_dec_and_test(&txd->cmd_cnt)) {
			spin_lock(&vchan->vc.lock);
			txd->vd.tx_result.result = DMA_TRANS_POLLINGTIMEOUT;
			xdx_vchan_cookie_complete(&txd->vd);
			spin_unlock(&vchan->vc.lock);
		}
	}
}

static void xdx_dma_interrupt_buserr_b0(struct xdx_dma_dev *sdev, struct xdx_pchan *pchan,
					unsigned int i, uint64_t BusErrRawSts)
{
	struct xdx_vchan *vchan;
	struct xdx_desc *txd;
	uint32_t cmd_tag;

	while (BusErrRawSts) {
		cmd_tag = GetLeadOnefromU64(BusErrRawSts);
		BIT_UNSET(BusErrRawSts, cmd_tag);

		txd = pchan->cmdRef[cmd_tag].desc;
		vchan = pchan->cmdRef[cmd_tag].vchan;

		spin_lock(&pchan->lock);
		xdx_dma_reset_b0(sdev);
		spin_unlock(&pchan->lock);

		if (txd && atomic_dec_and_test(&txd->cmd_cnt)) {
			spin_lock(&vchan->vc.lock);
			txd->vd.tx_result.result = DMA_TRANS_BUSSERR;
			xdx_vchan_cookie_complete(&txd->vd);
			spin_unlock(&vchan->vc.lock);
		}
	}
}


/*interrupt handler will run in tasklet which inplemented by soft IRQ*/
static int xdx_vdma_interrupt_b0(struct xdx_dma_dev *sdev)
{
	struct xdx_pchan *pchan;
	uint64_t CmdCmplRawSts, PollingTimeoutRawSts, BusErrRawSts;
	int i;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &sdev->pchans[i];
		if (pchan->submit_cmd) {
			CmdCmplRawSts = VDMA_B0_CH_RdAndClrCmdCmplRawSts((uint64_t)pchan->base);
			if (likely(CmdCmplRawSts))
				xdx_dma_interrupt_cmdcmpl_b0(pchan, CmdCmplRawSts);
			PollingTimeoutRawSts = VDMA_B0_RdAndClrPollingTimeoutRawSts((uint64_t)sdev->base, i);
			if (unlikely(PollingTimeoutRawSts))
				xdx_dma_interrupt_pollingtimeout_b0(sdev, pchan, i, PollingTimeoutRawSts);
			BusErrRawSts = VDMA_B0_RdAndClrBusErrRawSts((uint64_t)sdev->base, i);
			if (unlikely(BusErrRawSts))
				xdx_dma_interrupt_buserr_b0(sdev, pchan, i, BusErrRawSts);
		}
		if (!atomic_read(&sdev->tasklet_shutdown) && (sdev->pendingMask)) {
			tasklet_schedule(&sdev->task);
		}
	}
	return 0;
}


static int irq_set_en_b0(struct xdx_dma_dev *sdev, u32 enable)
{
	struct xdx_pchan *pchan;
	int i;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &sdev->pchans[i];
		VDMA_B0_EnDisChIntr((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx), !!enable);
	}
	return 0;
}

static int irq_set_tdma_en_b0(struct xdx_dma_dev *sdev, u32 enable)
{
	struct xdx_pchan *pchan;
	int i;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &sdev->pchans[i];
		TDMA_EnDisIntr((uint64_t)sdev->base, !!enable);
	}
	return 0;
}

static int xdx_tdma_hw_init_b0(struct xdx_dma_dev *sdev)
{
	TDMA_NdfAxiCtrl_T rNdfAxiCtrl;
	TDMA_HostAxiCtrl_T rHostAxiCtrl;
	uint64_t tdma_base_addr = (uint64_t)sdev->base;
#if defined(XDXGPU_SMMU_SUPPORT)
	TDMA_StreamId_T sSid;

	sSid.RpaSid = 0;
	sSid.RvaSid = 1;
	sSid.WpaSid = 0;
	sSid.WvaSid = 1;
	TDMA_SetStreamId(tdma_base_addr, &sSid);
#endif

	rNdfAxiCtrl.all = 0;
	rNdfAxiCtrl.ArLen = TDMA_COM_AXLEN_8;
	rNdfAxiCtrl.AwLen = TDMA_COM_AXLEN_8;
	rNdfAxiCtrl.AwCache = 0xf;
	TDMA_WrNdfAxiCtrl(tdma_base_addr, rNdfAxiCtrl.all);

	rHostAxiCtrl.all = 0;
	rHostAxiCtrl.ArLen = TDMA_COM_AXLEN_8;
	TDMA_WrHostAxiCtrl(tdma_base_addr, rHostAxiCtrl.all);

	TDMA_WrNdfOutStandingNum(tdma_base_addr, 512);
	TDMA_EnDisIntr((uint64_t)sdev->base, 1);
	return 0;
}


#define TDMA_INT_ENABLE_MASK (1<<4)
static int xdx_tdma_interrupt_b0(struct xdx_dma_dev *sdev)
{
//	struct xdx_dma_dev *sdev = platform_get_drvdata(dev_id);
	struct xdx_vchan *vchan;
	struct xdx_pchan *pchan;
	struct xdx_desc	*txd;
	uint32_t cmd_tag;
	uint64_t CmdCmplRawSts;
	uint64_t tdma_base_addr = (uint64_t)sdev->base;
	void __iomem *Tdma_Int_regs;
	IMG_UINT32 hostmisc_val;

	Tdma_Int_regs = sdev->hostmisc_base + 4;
	hostmisc_val = *(IMG_UINT32 *)Tdma_Int_regs;
	hostmisc_val &= ~TDMA_INT_ENABLE_MASK;
	*(IMG_UINT32 *)Tdma_Int_regs = hostmisc_val;

	pchan = &sdev->pchans[0];
	if (pchan->submit_cmd) {
		CmdCmplRawSts = TDMA_RdCmdCmplRawSts(tdma_base_addr);
		TDMA_WrCmdCmplClrReg(tdma_base_addr, CmdCmplRawSts);
		while(CmdCmplRawSts) {
			cmd_tag = GetLeadOnefromU64(CmdCmplRawSts);
			BIT_UNSET(CmdCmplRawSts, cmd_tag);
			txd = pchan->cmdRef[cmd_tag].desc;
			vchan = pchan->cmdRef[cmd_tag].vchan;
			spin_lock(&pchan->lock);
			xdx_dma_release_command_tag(pchan, cmd_tag);
			spin_unlock(&pchan->lock);
			DBG_ASSERT(txd->cmd_cnt.counter);
			OSAtomicDecrement((atomic_t *)&txd->cmd_cnt);
			if (0 == txd->cmd_cnt.counter) {
				spin_lock(&vchan->vc.lock);
				xdx_vchan_cookie_complete(&txd->vd);
				spin_unlock(&vchan->vc.lock);
			}
		}
	}

	if (!atomic_read(&sdev->tasklet_shutdown) && (sdev->pendingMask)) {
		tasklet_schedule(&sdev->task);
	}
	hostmisc_val |= TDMA_INT_ENABLE_MASK;
	*(IMG_UINT32 *)Tdma_Int_regs = hostmisc_val;
	return 0;
}

static int xdx_dma_print_reg_b0(struct xdx_dma_dev *sdev)
{
	struct xdx_pchan *pchan;
	int i;

	if ((sdev->dcfg->flags & XDXDMA_B0_VDMA_MASK) == XDXDMA_B0_VDMA_MASK) {
		for (i = 0; i < sdev->num_pchans; i++) {
			pchan = &sdev->pchans[i];
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->CTRL				0x%08x\n", i,
				VDMA_B0_RdCtrlReg((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->CHANNEL_IDLE			0x%08x\n", i,
				VDMA_B0_RdChannelIdleReg((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->CMD_CMPL_RAW_STS		0x%08llx\n", i,
				VDMA_B0_RdCmdCmplRawSts((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->POLLING_TIMEOUT_RAW_STS		0x%08llx\n", i,
				VDMA_B0_RdPollingTimeoutRawSts((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->BUS_ERR_RAW_STS			0x%08llx\n", i,
				VDMA_B0_RdBusErrRawSts((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->CMD_FIFO_STS			0x%08x\n", i,
				VDMA_B0_RdCmdBufOverflowSts((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx)));
		}
	} else if ((sdev->dcfg->flags & XDXDMA_B0_TDMA_MASK) == XDXDMA_B0_TDMA_MASK) {
		for (i = 0; i < sdev->num_pchans; i++) {
			pchan = &sdev->pchans[i];
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->CMD_CMPL_RAW_STS 	0x%08llx\n", i,
				TDMA_RdCmdCmplRawSts((uint64_t)sdev->base));
			XDX_DMA_ERR(sdev->dev, "Ch[%d]->BUS_ERR_RAW_STS			0x%08llx\n", i,
				TDMA_RdBusErrRawSts((uint64_t)sdev->base));
		}
	}
	return 0;
}

static int xdx_dma_cmd_buffer_remain_b0(struct xdx_pchan *pchan)
{
	DBG_ASSERT(NULL != pchan);
	return VDMA_B0_GetChCmdRemainSize((uint64_t)pchan->base);
}

static int xdx_tdma_cmd_buffer_remain_b0(struct xdx_pchan *pchan)
{
	DBG_ASSERT(NULL != pchan);
	return TDMA_GetCmdRemainSize((uint64_t)pchan->base);
}

struct xdx_dma_ops vdma_b0_ops = {
	.irq_set_en = irq_set_en_b0,
	.irq_handler = xdx_vdma_interrupt_b0,
	.issue_chan = xdx_dma_issue_vdma_b0,
	.package_cfg = xdx_dma_package_cfg_b0,
	.parse_sgls = xdx_dma_parse_sgls_b0,
	.print_reg = xdx_dma_print_reg_b0,
	.cmd_buffer_remain = xdx_dma_cmd_buffer_remain_b0,
};

struct xdx_dma_ops tdma_b0_ops = {
	.hw_init = xdx_tdma_hw_init_b0,
	.irq_set_en = irq_set_tdma_en_b0,
	.irq_handler = xdx_tdma_interrupt_b0,
	.issue_chan = xdx_dma_issue_tdma_b0,
	.package_cfg = xdx_dma_package_cfg_b0,
	.parse_sgls = xdx_dma_parse_sgls_b0,
	.print_reg = xdx_dma_print_reg_b0,
	.check_paras = xdx_tdma_para_check_b0,
	.cmd_buffer_remain = xdx_tdma_cmd_buffer_remain_b0,
};

