/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#pragma once


#include "SysTypes.h"
#include "BootStage.h"
#include "PCIeEvent.h"
#include "ACPUEvent.h"
#include "XDMAManager.h"
#include "VDMAManager.h"
#include "PowerManager.h"
#include "WatchDogs.h"
#include "FwControl.h"
#include "KCCBManager.h"
#include "ACCBManager.h"
#include "VCCBManager.h"
#include "FreeRTOSShared.h"
#include "GDDRStatistics.h"
#include "GDDRTemperature.h"


typedef struct
{
    __V U32 selfSize;						//0x0
    __V ACPUBootStage_T acpuBootStage;		//
    __V CMCUBootStage_T cmcuBootStage;		//
    __V VDMCU0BootStage_T vdmcu0BootStage;	//
    __V VDMCU1BootStage_T vdmcu1BootStage;	//
    __V PCIeEvent_T pcieEvent;				//
    __V ACPUEvent_T acpuEvent;				//
    U32 versionString[16];
    U32 vbiosVersionString[16];
    __V S32 socTemp;
    __V FreeRTOSStaticEventGroup_T eventGroupBuffer;
    __V WatchDogs_T watchDogs;
    __V U64 glbTSBase;
    __V U64 crTSBase;
    __V U32 hdbaEvent;
    __V U32 dcIntHelper;
    __V U32 hdmiHPDIntHelper;
    __V U32 gpuPrimaryCoreID;
    __V U32 debugFlags;
    __V GDDRTemperature_T gddrTemp;
    __V GDDRStat_T gddrStat;
    __V FwCapability_T fwCapability;
    __V FwControl_T fwControl;
    __V PowerManager_T powerMgr;
    __V XDMAManager_T xdmaMgr;
    __V VDMAManager_T vdma0Mgr;
    __V VDMAManager_T vdma1Mgr;
    __V KCCBManager_T kccbMgr;
    __V ACCBManager_T accbMgr;
    __V VCCBManager_T vccbMgr;
} FwGlobalStruct_T;

