/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */

#ifndef __XDX_SMMU_H_
#define __XDX_SMMU_H_
#include "xdx_shared.h"
#include "pangu.h"
#include "xdx_drv.h"
#include "xdx_irq.h"

#define XDX_SMMU_STAT_INITED       (1 << 0)
#define XDX_SMMU_STAT_INSUSPEND    (1 << 1)
#define XDX_SMMU_STAT_SHUTDOWNED   (1 << 2)

#define XDX_SMMU_VALID_STATS       (XDX_SMMU_STAT_INITED)

struct xdx_smmu {
	struct xdx_ip_block base;
	struct xdx_irq_src *irq_src;
	void *xsmmu;
	struct list_head ctxs_head;
	uint32_t stat;
};

static inline bool xdx_smmu_valid(struct xdx_smmu *smmu)
{
	return smmu->stat == XDX_SMMU_VALID_STATS;
}

static inline bool xdx_smmu_is_inited(struct xdx_smmu *smmu)
{
	return smmu->stat & XDX_SMMU_STAT_INITED;
}

extern const struct xdx_ip_block_version smmu_ip_block_pangu;

#endif
