/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */

#ifndef _HANTRODEC_H_
#define _HANTRODEC_H_
#include <linux/ioctl.h>
#include <linux/types.h>
#include "hantro_priv.h"
#include "hantro.h"

#undef PDEBUG
#ifdef HANTRODEC_DEBUG
#ifdef __KERNEL__
#define PDEBUG(fmt, args...) pr_info("hantrodec: " fmt, ##args)
#else
#define PDEBUG(fmt, args...) fprintf(stderr, fmt, ##args)
#endif
#else
#define PDEBUG(fmt, args...)
#endif

int hantrodec_release(struct file *filp);
int hantrodec_init(void);
int hantrodec_probe(struct xdx_device *xdev, dtbnode *pnode, int useirq, int loop,
		    struct hantrodec_t *pdeccore);
void hantrodec_cleanup(struct xdx_device *xdev);
long hantrodec_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
u32 *hantrodec_getRegAddr(u32 coreid, u32 regid);
int hantrodec_open(struct inode *inode, struct file *filp);
u32 hantrodec_readbandwidth(struct xdx_device *xdev, int sliceidx, int isreadBW);

/* IRQ handler */
irqreturn_t hantrodec_isr(int irq, void *dev_id);

#endif /* !_HANTRODEC_H_ */
