/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef XDXVPU_IRQ_H
#define XDXVPU_IRQ_H

#include "xdx_device.h"
#include "hantro_priv.h"

#define VDEC_INT_VECTOR		26
#define VENC_INT_VECTOR		27

#define VCMD_ENC_MODULE_TYPE_0			0
#define VCMD_DEC_MODULE_TYPE_0			2

#define VDEC_REG_IRQ_STATUS			0x4
#define VENC_REG_IRQ_STATUS			0x4
#define DEC_ENC_REG_SIZE			0x100

#define VCMD_REG_IRQ_SOURCE			0x08 //swreg2
#define VCMD_REG_IRQ_STATUS			0x44 //swreg17
#define VCMD_REG_IRQ_CONTROL		0x48 //swreg18
#define VCMD_REG_IRQ_CPU_GATE		0x64 //swreg25

#define VCMD_EXT_IRQ_VCE			(0x1<<0)
#define VCMD_EXT_IRQ_Cutree			(0x1<<1)
#define VCMD_EXT_IRQ_DEC400_VCE		(0x1<<2)
#define VCMD_EXT_IRQ_L2Cache_VCE	(0x1<<3)
#define VCMD_EXT_IRQ_MMU_VCE		(0x1<<4)
#define VCMD_EXT_IRQ_MMU_Cutree		(0x1<<5)

#define VCMD_EXT_IRQ_VCD			(0x1<<8)
#define VCMD_EXT_IRQ_DEC400_VCD		(0x1<<9)
#define VCMD_EXT_IRQ_L2Cache_VCD	(0x1<<10)
#define VCMD_EXT_IRQ_MMU_VCD		(0x1<<11)

extern void vpuirq_dec_work_handle(struct work_struct *work);
extern void vpuirq_enc_work_handle(struct work_struct *work);
#endif

