/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_DRM_H__
#define __XDX_DRM_H__

#include <linux/atomic.h>
#include <linux/wait.h>
#include <linux/list.h>
#include <linux/kref.h>
#include <linux/rbtree.h>
#include <linux/hashtable.h>
#if (LINUX_VERSION_CODE < KERNEL_VERSION(4, 10, 0)) && !defined(CHROMIUMOS_KERNEL_HAS_DMA_FENCE) && (!defined(XDXGPU_CENTOS79_SUPPORT))
#include <linux/fence.h>
#else
#include <linux/dma-fence.h>
#endif
#include <linux/pci.h>
#include <linux/aer.h>
#include <drm/drm_vma_manager.h>

#include <drm/drm_gem.h>
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 12, 0))
#include <drm/drm_ioctl.h>
#endif
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 5, 0)) || (defined(REDHAT_83)) || (defined(XDXGPU_CENTOS85_SUPPORT))
#include <drm/drm_device.h>
#include <drm/drm_file.h>
#else
#include <drm/drmP.h>
#endif
struct xdx_drm_fpriv {
	struct drm_file *dfile;
	uint32_t connection_id;
	void *pvr_fpriv;
	void *vpu_fpriv;
};

int xdx_file_to_fpriv(struct file *filp, struct xdx_drm_fpriv **fpriv);

#endif /* __XDX_DRM_H__ */
