/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_GFX_H__
#define __XDX_GFX_H__

#include <drm/drm_vma_manager.h>
#include "xdx_drm.h"
#include "xdx_shared.h"


struct xdx_device;

struct xdx_gfx {
	struct xdx_ip_block base;

	void *pvrdev;
	long gfx_timeout;
	long compute_timeout;
	struct xdx_irq_src *irq_src;

        /* gpu mem snapshot */
#define XDX_SNAPSHOT_HEAP_MAX        4 /* GPU local,private,mmu,dc */
	void *pvr_heap_iter[XDX_SNAPSHOT_HEAP_MAX];
 	void *pvr_pwr_buffer[XDX_SNAPSHOT_HEAP_MAX];
};

int xdx_gfx_drm_open(struct xdx_device *xdev, struct xdx_drm_fpriv *fpriv);
void xdx_gfx_drm_release(struct xdx_device *xdev, struct xdx_drm_fpriv *fpriv);

extern const struct xdx_ip_block_version volcanic_block_version;

#endif /* __XDX_GFX_H__ */
