/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 5, 0)) || (defined(REDHAT_83)) || (defined(XDXGPU_CENTOS85_SUPPORT))
#include <drm/drm_device.h>
#include <drm/drm_file.h>
#else
#include <drm/drmP.h>
#endif
#include <drm/drm_vma_manager.h>

#include "xdx_device.h"
#include "rgxdevice.h"

static inline struct xdx_device *gfx_to_xdev(PVRSRV_DEVICE_NODE *psDeviceNode)
{
    PVRSRV_DEVICE_CONFIG   *psDevConfig = psDeviceNode->psDevConfig;
    void *pvOSDevice = psDevConfig->pvOSDevice;
    struct device *dev = pvOSDevice;
    struct drm_device *ddev = dev_get_drvdata(dev);
    struct xdx_device *xdev = drm_to_xdev(ddev);
    return xdev;
}

#if defined(SUPPORT_PANGU_ACPU)
int32_t Do_ACPUTINYCOPY(PVRSRV_RGXDEV_INFO *psDevInfo, uint32_t bitmap, bool bIsUserBuffer);
uint32_t Do_ACPUTINYCOPYNonBlock(PVRSRV_RGXDEV_INFO *psDevInfo, uint32_t bitmap, bool bIsUserBuffer);
void Wait_ACPUTINYCOPY(PVRSRV_RGXDEV_INFO *psDevInfo, uint32_t dbNum,  uint32_t bitmap);
void Sharemem_ACPUMEMSET(PVRSRV_RGXDEV_INFO *psDevInfo, uint32_t *pBitmap, 
									uint64_t devPAddr, uint32_t size, uint32_t pattern);
uint32_t TinyBufferPoolGet(PVRSRV_RGXDEV_INFO *psDevInfo, bool bTryAgain);
void TinyBufferPoolPuts(PVRSRV_RGXDEV_INFO *psDevInfo, uint32_t ui32BitMap, bool bIsUserBuffer);
int32_t ACPUTINYMEMSET(PVRSRV_DEVICE_NODE *psDeviceNode, uint64_t devPAddr, uint32_t size, uint32_t *data);                  
int acpu_tiny_memset_package(PVRSRV_DEVICE_NODE *psDevNode, uint64_t devPAddr, uint32_t size, uint32_t *data);
int acpu_tiny_copy_package(PVRSRV_DEVICE_NODE *psDevNode, uint64_t devPAddr, uint64_t srcPAddr, uint32_t size);
#endif

