/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_VDMA_H__
#define __XDX_VDMA_H__

#include "xdx_shared.h"

/* display manager */
struct xdx_vdma {
	struct xdx_ip_block base;
	struct xdx_irq_src *irq_src;
	const struct vdma_funcs *funcs;
	void __iomem			*vdma0_rmmio;
	void __iomem			*vdma1_rmmio;
	resource_size_t vdma0_rmmio_base;
	resource_size_t vdma1_rmmio_base;
	resource_size_t vdma0_rmmio_size;
	resource_size_t vdma1_rmmio_size;
	struct device *dma_dev;
};

struct xdx_dma_platdata_t {
	void *xdx_dev;
};

int xdx_dma_dev_init(struct xdx_device *xdev);
int xdx_dma_dev_finit(struct xdx_device *xdev);

#endif /* __XDX_VDMA_H__ */

