/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_VPU_H__
#define __XDX_VPU_H__

#include <linux/list.h>
#include "xdx_shared.h"

struct xdx_vpu {
	struct xdx_ip_block base;
	struct xdx_irq_src *irq_src;
	struct work_struct vpuirq_dec_work;
	struct work_struct vpuirq_enc_work;
	struct workqueue_struct *vpu_workq;
	int vpuirq_dec_status;
	int vpuirq_enc_status;

	struct list_head vcmd_slice;
	struct list_head slice_head;
	u32 config;

};

struct vpu_mm {
	struct list_head bo_list;
	struct mutex mutex;

};

struct vpu_fpriv {
	struct vpu_mm mm;
	void *vcmd;
};


int xdx_vpu_isr_install(struct xdx_device *xdev);
int vpu_isr_uninstall(struct xdx_device *xdev);
int xdx_vpu_init(struct xdx_device *xdev);
int xdx_vpu_fini(struct xdx_device *xdev);

extern const struct xdx_ip_block_version vpu_ip_block_version;
int xdx_vpu_drm_open(struct xdx_device *xdev, struct xdx_drm_fpriv *fpriv);
void xdx_vpu_drm_release(struct xdx_device *xdev, struct xdx_drm_fpriv *fpriv);

#endif /* __XDX_VPU_H__ */
